# Hekili

## [v10.0.0-01](https://github.com/Hekili/hekili/tree/v10.0.0-01) (2022-10-28)
[Full Changelog](https://github.com/Hekili/hekili/compare/v9.2.5-1.0.10...v10.0.0-01) [Previous Releases](https://github.com/Hekili/hekili/releases)

- Quickfix for #1717  
- BM: Cobra Shot less, maybe (#1733)  
- Add Primordial Wave (talent) aura (#1736)  
- Attempt quickfix for New/Half/Full Moon SpellFlash (#1745)  
- Attempt quickfix for Lunar Inspiration SpellFlash (#1745)  
- MM:  Disable focus cap check (Fix #1748)  
- Enable Fae Transfusion for Enhancement (#1749)  
- Retribution Paladin.  
- BM and Marksman priority recheck.  
- Recheck Vengeance priority.  
- Enhancement, Havoc APL recheck.  
- Update status list.  
- Add Convoke to covenant spell list.  
- Guardian again.  
- Feral and Guardian APL recheck.  
- Balance APL recheck.  
- Fix ResetQueues.  
- Remove Shadowlands class files.  
- More status info at login and in /hekili.  
- DK priority updates.  
- Add warning message at login.  
- Differentiate Death Chakram debuff from the ticks for resource generation.  
- Revise load order for spec modules (current > other specs > shared).  
- Arms backup detection for Rend.  
- Protection Warrior quickfixes.  
- Covenant quickfixes.  
- Update Bloodlust/Sated.  
- Move Fury of the Aspects to shared table.  
- Set up cl\_crash\_lightning.  
- Revise Covenant check to base on spell ID.  
- Marksmanship.  
- Fix Balance Stellar Flare issue.  
- Beast Mastery Hunter.  
- Protection Warrior.  
- Arms.  
- Fury.  
- Fix Guardian "incarnation" talent alias.  
- Merge branch 'dragonflight' of https://github.com/Hekili/hekili into dragonflight  
- .  
- Stop embedding Bliz options.  
- Replace shared aura detection.  
- Merge pull request #1700 from Wyste/patch\_war\_df  
    [Warrior] Prepatch fixes/tweaks  
- Fix queues.  
- Fix up Elemental.  
- Fix Windfury Totem for Enhancement.  
- Remove Stormkeeper from Enhancement.  
- [Warrior] Arms leggo and conduits readded  
- [Warrior] Fury small fixes + conduits/leggo pass  
- Warn about classes that are NYI.  
- Whoops, fix GetUnitByGUID until 10.0.2.  
- [Warrior] prot add conduits and leggos back in  
- Demon Hunters.  
- Fix Covenant ability detection.  
- Death Knights.  
- Blood DK.  
- Filter damaged enemies by whether they are on screen.  
- Use BigWigsPackager v2.  
- Disable Covenant spells outside of Shadowlands.  
- Fix Feral (sorry kitty).  
- Fix refreshable, etc.  
- Force updates more quickly on successful spellcast.  
- Add missing Sabertooth debuff.  
- Fix item CD detection.  
- Fix Balance, Feral APLs.  
- Match TOC.  
- Warning message.  
- Enhancement APL.  
- Guardian APL.  
- Balance APL.  
- Feral APL.  
- Feral.  
- Resource sanity.  
- Balance.  
- Guardian.  
- Set default value for health.  
- Vengeance.  
- Havoc full talents.  
- DHs.  
- Typo.  
- Merge branch 'dragonflight' of https://github.com/Hekili/hekili into dragonflight  
- Druid/Evoker/Shaman updates.  
- Merge pull request #1670 from Wyste/dragonflight  
- DKs.  
- Fix initial health.  
- Minor DF adjustments.  
- Event tweaks.  
- [Warrior] All specs refactored execute  
- [Warrior] Arms refactored excute to fit SL's model changed for DF  
- [Warrior] Arms warrior in for the kill and haste buff check  
- [Warrior] All spec intimidating shout id copy  
- [Warrior] Arms only apply in for the kill and haste buff when buff is down  
- [Warrior] arms remove rage gen for BS  
- [Warrior] Arms switch RegisterAuras to RegisterAura for t29 4pc  
- [Warrior] Arms denest test\_of\_might AuraExpiration within reset\_precast  
- [Warrior] All spec reimplement FindPlayerAuraByID for Conq banner  
- [Warrior] Arms remove modeling of melee crits since they cannot be forecasted  
- [Warrior] All spec rallying cry is now shared to player and cooldown toggle  
- [Warrior] Arms fix typo for duration of colossus smash  
- [Warrior] Arms revert melee swings back to previous formula  
- [Warrior] Arms/Fury DF set bonuses defined  
- [Warrior] fury fix id t-clap between beta/ptr  
- [Warrior] Arms add AuraExpiration events to RegisterAbilities  
- [Warrior] Fury PTR Build 46181 and revamp  
- [Warrior] Arms tclap and intimidating shout ID fix  
- [Warrior] Prot Glory is every 10 rage, not 20 for prot  
- [Warrior] Arms add rallying\_cry aura back  
- [Warrior] Prot better variable descriptor  
- [Warrior] Prot fix for wrong variable name  
- [Warrior] Prot removed unused funcs  
- [Warrior] Arms Tclap / In for the kill update  
- [Warrior] Prot t29, pummel interrupt, and settings update  
- [Warrior] Beta Build 46144  
- Spec change simplification.  
- Update gitignore.  
- [Warrior] Prot turn virtual/emulated spenders on  
- [Warrior] Prot remove some debug prints  
- [Warrior] Fury, handle rage decay  
- [Warrior] Prot Remodel Unit\_power\_frequent  
- [Warrior] Test of Might is tricky to track  
- [Warrior] Arms Rage spender refactor  
- [Warrior] Arms implement Test of Might  
- [Warrior] Rage spender refactor  
- [Warrior] remove some todo comments  
- [Warrior] remove Prot's unnerving\_focus from spear of bastion  
    and clean up some TODO's and comments  
- trim moar whitespace cuz i'm superbad  
- [Warrior] set prot's def\_stance as essential  
- remove def\_stance as essential  
- trim trialing whitespace cuz i'm bad  
- [Warrior] Fury PTR Build 46047 Complete Writeup  
- [Warrior] Arms minor tweaks to abilities  
- [Warrior[ Arms rage normalization + Seasoned Soldier  
- [Warrior] Arms remove unneeded FindPlayerAuraByID  
- [Warrior] Arms update blood and thunder mechs  
    for PTR build 46047  
- [War] Prot PTR 46047 Blood+Thunder fix  
- [Warrior] Fix error in Prot UNIT\_POWER\_FREQUENT  
- [Warrior] Remove Glory's ns.FindUnitBuffByID usage  
- Warrior Arms Beta Build 45969 talent update  
- Merge pull request #1647 from Qperquin/dragonflight  
    Full pass of all elemental shaman buffs, talents and abilities  
- fixing more style errors  
- replacing tabs with 4 spaces wherever this happened  
- handling PR feedback  
- Merge pull request #1642 from Wyste/patch\_prot\_war-2  
    Prot Warrior Beta Build 45969 Changes/Fixes  
- Merge pull request #1634 from Wyste/patch\_arms\_war-1  
    update WarriorArms.lua for beta 45779  
- Few more small fixes  
- Full pass of all elemental shaman buffs, talents and abilities  
- Hekili comment review + fixes  
    Added Unnerving Focus to Demoralizing Shout (Booming Voice) rage gain.
  
    Modified syntax of rage spenders / gains to conform to Hekili's syntax.
  
    Syntax correction for ravager's duration made
  
    Outburst rage tracker logic modified.
  
    Typo's fixed.
  
    Fixed Shield Slams spender to be negetive (gain rage) and handle both forms of outburst as independant if blocks.
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989204340
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989202400
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989202126
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989198190
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989196182
  
    Addresses https://github.com/Hekili/hekili/pull/1642#discussion\_r989194838  
- Fix unnerving focus rage multiplier  
- Build 45969 changes + additional fixes  
    Build 45969 changes:
  
    - avatar updated to gain 10 rage instead of 15, and handle JUST the tier28 outburst mechanic
  
    - booming voice talent gives 30 rage now instead of 40
  
    - removed everything related to wrenching impact being removed
  
    - changed heroic throw cooldown to 1sec
  
    - shield charge gives 20 rage instead of 30
  
    - thunder clap and shield slam modified to give 50% more rage for violent\_outburst being up (was flat 10/30 rage respectively)
  
    - thunder clap and shield slam modified to handle tier28 and talent outburst buffs separately
  
    - titanic\_throw cooldown updated to 3 seconds
  
    - added hasteCD to tclap
  
    - extend ravager's duration by 2 sec (hasted) using dance of death talent
  
    - Impenetrable Wall – Now grants Shield Slam 3 extra Rage (was 5).
  
    - Heavy Repercussions – Now grants Shield Slam 2 extra Rage (was 3).
  
    - Champion’s Bulwark – Grants 20 bonus Rage (was 30).
  
    - changed thunderlord's max CD reduction to 3 seconds from 4
  
    Fixes:
  
    - rename tier28 outburst to outburst and outburst\_buff due to the DF talent being called violent\_outburst now)
  
    - UNIT\_POWER\_FREQUENT updated to handle either tier28 or violent outburst talent enabled
  
    - hook "spend"  updated to handle either tier28 or violent outburst talent enabled  
- fix capitalization/syntax identified by hekili  
    Ref: https://github.com/Hekili/hekili/commit/74daf9057cb92355df55606f5db31b1ed90f93b6#r85909603
  
    Ref: https://github.com/Hekili/hekili/commit/74daf9057cb92355df55606f5db31b1ed90f93b6#r85909742  
- dance of death is affected by haste  
    Reference: https://github.com/Hekili/hekili/commit/74daf9057cb92355df55606f5db31b1ed90f93b6#r85919540  
- impl Dance of Death, Collateral Damage, Hurricane  
    Properly implement Dance of Death cooldown extension for Bladestorm.
  
    Properly implement Collateral Damage stacks gained after Sweeping Strikes ending
  
    Properly implement Merciless Bonegrinder being applied after Bladestorm ends.
  
    Add exploiter Aura to cover SL Legendary  
- Add hurricane/ dance of death and MbG auras (NYI)  
- update WarriorArms.lua for beta 45779  
    Gone through the entire list of talents / abilities and researched each ability and buff individually.
  
    Tested in-game and get 0 errors using a crude modified APL from SL.
  
    There are a few assumptions:
  
    Legendaries will be disabled in DF but still active in SL zones, so some legendary logic remains.
  
    Conduits are completely removed from all logic. (most got converted to talents anyways)
  
    Covenant ability logic remains, where as the definitions of abilities / buffs are maintained in Shadowlands/Covenants.lua already.  
- Merge pull request #1626 from Wyste/patch\_prot\_war\_1  
    update prot warrior for DF  
- Merge pull request #1632 from Wyste/patch\_ui\_bug  
    fix stopScreenMovement bug when dragging UI elements  
- fix stopScreenMovement bug when dragging UI elements  
- uproar talent CD reduction logic applied  
- update spell reflection's cooldown to 25  
    I typo'd this originally  
- update spear of bastion duration to correct values  
- bump build version at top of file  
    whoopsie  
- Update prot war for build 45779  
    - Talents regenerated from skeleton
  
    - Avatar from 20 to 15 rage gen
  
    - Thunderous roar gens 10 rage (was previously nothing in my version, but should have been 20)
  
    - Piercing Verdict talent modifies Spear of Bastion ability:  went from 50% extra rage gen to 100%
  
    - Shield Slam now gets CD reduction from Honed Reflexes
  
    - Pummel now gets CD reduction from Honed Reflexes (in addition to Concussive Blows too!)
  
    Renames:
  
    - Outburst (talent) renamed to Violent Outburst ( verified spellID did not change )
  
    - Quick Thinking renamed to Wild Strikes (talent)
  
    - The Wall renamed to Impenetrable Wall (talent)
  
    - Spiked Shield renamed to Tough as Nails (talent)
  
    - Siphoning Strikes renamed to Leeching Strikes (talent)  
- handle tier28 outburst vs talented outburst  
    In-game testing shows that seeing\_red is two separate buffs and provides (at 8 stacks) two separate outburst buffs.  
- comment build information at top of file  
- update WarriorProtection.lua for beta 45746  
    Gone through the entire list of talents / abilities and researched each ability and buff individually.
  
    There are a few assumptions:
  
    Legendaries will be disabled in DF but still active in SL zones, so some legendary logic remains.
  
    Conduits are completely removed from all logic. (most got converted to talents anyways)
  
    Covenant ability logic remains, where as the definitions of abilities / buffs are maintained in Shadowlands/Covenants.lua already.  
- Update Evokers.  
- Druid talent/aura updates and corrections.  
- Update DF talents.  
- Update Demon Hunters.  
- Unholy model update.  
- Fallback to config ID of -1 when the API doesn't return anything useful.  
- Frost DK updates.  
- Blood corrections.  
- Update auras.  
- Imported Warrior auras.  
- Touch up internal ability list.  
- Add legacy Runes resources to DKs.  
- Adjust PvP trinkets and ability sorting.  
- Add initial DH, DKs with imported auras.  
- Add initial Monk models with imported auras.  
- Initial Druid model with imported auras.  
- Label aura data for export to avoid confusion.  
- Quickfix for NYI talents with spellID of 0.  
- Move Paladin and Warlock Covenant abilities to SL file.  
- Initial Paladin models with imported auras.  
- Imported Warlock auras.  
- Add Warlock skeletons.  
- Discipline auras.  
- Shadow auras (again).  
- Shadow pre-test.  
- Holy aura reimport.  
- Test autoloader for Priest auras.  
- Corrections to Priests.  
- Skeleton quickfix.  
- Add Hunters and fix talent IDs.  
- Account for Loss of Control on ability cooldowns (i.e., recover from having a spell school locked).  
- More skeleton tool tinkering.  
- Initial Mage/Priest/Rogue commit.  
- "Borrow" WeakAuras' luacheckrc.  
- Ele PvP talents (wip).  
- Warrior skeletons.  
- More tweaks to skeletons.  
- Replicate SL GPABSI.  
- Moist talent info for completeness.  
- Grab talent ranks for Elemental.  
- Finish Enhancement talents.  
- Enhancement talents.  
- Update spooky skeleton.  
- Translate most Shaman SL mechanics to DF.  
- Fix reactive fix.  
- Fix reactive display mode.  
- Blood priority adjustments.  
- Pass the indicator icon information to WeakAuras when recommendations are updated.  
- Balance, Guardian, Survival, Retribution priorities.  
- Arcane, Fire priorities.  
- Rogue priorities.  
- Demonology priority.  
- Blood DK:  Crimson Rune Weapon.  
- Preparation for 10.0.  
- Cache trinket fix.  
- Add 'empower\_to' in priority options.  
- Remove redundant helper.  
- Initial DF work-in-progress.  
